commit d4ab24c44d35aa70bec5835a09d840b13b42933f
Author: freddy77 <freddy77>
Date:   Thu Apr 8 07:36:49 2010 +0000

    Avoid hang on variant type if conversion enabled

diff --git a/ChangeLog b/ChangeLog
index defb1d7..02ded3d 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Thu Apr  8 09:36:21 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/token.c: Avoid hang on variant type if conversion enabled
+
 Mon Apr  5 14:45:37 EDT 2010	JK Lowden <jklowden@freetds.org>
 	* include/tds.h src/tds/token.c log table metadata succintly
 	* src/dblib/unittests/t0004.c test dbgetchar()
@@ -2375,4 +2378,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3003 2010/04/05 18:49:25 jklowden Exp $
+$Id: ChangeLog,v 1.3004 2010/04/08 07:36:49 freddy77 Exp $
diff --git a/src/tds/token.c b/src/tds/token.c
index d3de1ae..d62866a 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.381 2010/04/05 18:49:25 jklowden Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.382 2010/04/08 07:36:49 freddy77 Exp $");
 
 #define USE_ICONV tds->use_iconv
 
@@ -2110,12 +2110,13 @@ tds7_get_variant(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		TDS_ZERO_FREE(v->data);
 	if (colsize) {
 		if (USE_ICONV && curcol->char_conv) {
-			curcol->column_cur_size = colsize = determine_adjusted_size(curcol->char_conv, colsize);
-			v->data = (TDS_CHAR*) malloc(colsize);
+			curcol->column_cur_size = determine_adjusted_size(curcol->char_conv, colsize);
+			v->data = (TDS_CHAR*) malloc(curcol->column_cur_size);
 			if (!v->data)
 				return TDS_FAIL;
 			if (tds_get_char_data(tds, (char *) v->data, colsize, curcol) == TDS_FAIL)
 				return TDS_FAIL;
+			colsize = curcol->column_cur_size;
 			v->type = tds_get_cardinal_type(type, 0);
 		} else {
 			v->data = (TDS_CHAR*) malloc(colsize);

